##########################################################################
# έp (@)                                                            #
# Anderson et al., Statistics for Business & Economics (14th Edition)    #
# Chapter 4                                                              #
# d~ ߬FvjǲέpǨt                                            #
# http://www.hmwu.idv.tw/                                                #
##########################################################################



######################################
# Section 4.1                        #
######################################

5 * 4 * 3 * 2 * 1

prod(1:5)

factorial(5)

combn(5, 3)

choose(5, 3)


# install.packages("gtools")
library(gtools)
urn <- c("red", "blue", "black")
# pick 2 balls from the urn with replacement get all permutations
permutations(n = length(urn), r = 2, v = urn, repeats.allowed = T)
nrow(permutations(n = length(urn), r = 2, repeats.allowed = T))

combinations(3, 2, letters[1:3])



######################################
# Section 4.1                        #
######################################
sample(letters, 50, replace = T)


dice1 <- sample(1:6, 1)
dice2 <- sample(1:6, 1)
dice1 + dice2

n <- 2
my.dice <- function(n){
  dice.no <- sample(1:6, n, replace=T)
  dice.sum <- sum(dice.no)
  output <- c(dice.no, dice.sum)
  names(output) <- c(paste0("dice", 1:n), "sum")
  output
}
my.dice(3)
ans <- replicate(10000, my.dice(2))
length(which(ans[3,] == 2))/10000



######################################
# Section 4.3                        #
######################################

A <- c("a", "b", "c", "d", "e")
B <- c("d", "e", "f", "g")

union(A, B)
intersect(A, B)
setdiff(A, B)
setdiff(B, A)
setequal(A, B)
is.element(A, B)
is.element(B, A)



######################################
# Section 4.5                        #
######################################


# Bayes' Theorem (one event case)
# P(A | B) = (P(B | A) * P(A)) / P(B)


# Bayes' Theorem (two event case)
# https://search.r-project.org/CRAN/refmans/LaplacesDemon/html/BayesTheorem.html
# install.packages("LaplacesDemon")
library(LaplacesDemon)

# Supplier 1, 2; Good/Bad parts
# P(A1) = 0.65
# P(A2) = 0.35
# P(G | A1) = 0.98
# P(B | A1) = 0.02
# P(G | A2) = 0.95
# P(B | A2) = 0.05
# P(A1 | B) = ?  # 0.4262
# P(A2 | B) = ?  # 0.5738

# BayesTheorem(PrA, PrBA)
# PrA: the prior probability of A
# PrBA: the conditional probability of B given A


PrA <- c(0.65, 0.35)
PrBA <- c(0.02, 0.05)
BayesTheorem(PrA, PrBA)

